﻿using CoreGraphics;
using Syncfusion.SfDataGrid;
using System;
using System.Collections.Generic;
using System.Text;
using UIKit;

namespace SampleDemo
{
    public class MyViewController : UIViewController
    {

		SfDataGrid sfgrid;
        ViewModel vm;
        UIButton btn1;
		UIButton btn2;
        public MyViewController()
        {
            vm = new ViewModel();
            btn1 = new UIButton();
            sfgrid = new SfDataGrid();
            sfgrid.ItemsSource = vm.OrdersInfo;
			sfgrid.GridStyle = new CustomGridStyle();
            btn1.BackgroundColor = UIColor.Blue;
            btn1.SetTitle("ClickToHide", UIControlState.Normal);
            btn1.TouchUpInside += Btn_TouchUpInside;
			sfgrid.AutoGeneratingColumn += (sender, e) => 
			{
				if (e.Column.MappingName == "Freight")
					e.Column.UserCellType = typeof(GridCellExt);
			};
			btn2 = new UIButton();
			btn2.BackgroundColor = UIColor.Purple;
			btn2.SetTitle("ClickToUnhide", UIControlState.Normal);
			btn2.TouchUpInside += Btn2_TouchUpInside;

            View.AddSubview(sfgrid);
            View.AddSubview(btn1);
			View.AddSubview(btn2);

        }

        private void Btn_TouchUpInside(object sender, EventArgs e)
        {
			this.sfgrid.Columns[2].Width = 0;
        }

		void Btn2_TouchUpInside(object sender, EventArgs e)
		{
			this.sfgrid.Columns[2].Width = 100;
		}

        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();
            sfgrid.Frame = new CGRect(0, 0, 400, 400);
            btn1.Frame = new CGRect(0, 450, 400, 50);
			btn2.Frame = new CGRect(0, 550, 400, 50);
        }
    }

	public class GridCellExt : GridCell
	{
		UITextView textView = new UITextView();

		public GridCellExt()
		{			
			textView.TextColor = UIColor.Red;
			textView.BackgroundColor = UIColor.Clear;
			this.AddSubview(textView);

		}
		public override void OnCellValueChanged()
		{
			base.OnCellValueChanged();
			this.textView.Text = this.DataColumn.FormattedCellvalue;

		}

		public override void LayoutSubviews()
		{
			textView.Frame = new CGRect(0, 0, this.Frame.Width, this.Frame.Height);
			this.BackgroundColor = UIColor.Green;
		}
	}
}
